<!DOCTYPE html>

<html lang="en">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="theme-color" content="#000000">
    <meta name="author" content="Torbjorn Ludvigsen">
    <meta name="keywords" content="Hangprinter, open source, hardware, technology, software, Reprap, development">
    <meta name="description" content="Hangprinter">
    <meta property="og:type" content="website">
    <meta property="og:title" content="Hangprinter">
    <meta property="og:url" content="https://hangprinter.org/doc/v4">
    <meta property="og:description" content="Cable Driven RepRap">
    <meta property="og:image" content="https://hangprinter.org/hangprinter4_small.jpeg">
    <meta name="twitter:card" content="summary">
    <meta name="twitter:site" content="@tobbelobb">
    <meta name="twitter:creator" content="@tobbelobb">
    <link rel="stylesheet" href="../../style.css?v=0" type="text/css">
    <link rel="apple-touch-icon" sizes="180x180" href="../../apple-touch-icon.png">
    <link rel="icon" type="image/png" sizes="32x32" href="../../favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="16x16" href="../../favicon-16x16.png">
    <link rel="manifest" href="../../site.webmanifest">
    <link rel="mask-icon" href="../../safari-pinned-tab.svg" color="#5bbad5">
    <meta name="msapplication-TileColor" content="#00aba9">
    <meta name="theme-color" content="#ffffff">
    <title>Hangprinter|HP4 Manual</title>
  </head>
  <body style=width:100%;">
    <div class="masthead">
      <h3 class="masthead-brand">
        <a href="../../" style="text-decoration:none;color:#000;">
          <img src="../../safari-pinned-tab.svg" style="height:50px;width:50px;" />
        </a>
      </h3>
      <nav>
        <ul>
          <li>
            <div class="dropdown">
              <button class="dropbtn"><div class="active">Documentation</a></button>
              <div class="dropdown-content">
                <a href="../../doc/v3">Hangprinter version 3</a>
                <a href="." class="active">Hangprinter version 4</a>
              </div>
            </div>
          </li>
          <li><a href="../../contribute">Contribute</a></li>
          <li><a href="../../about">About</a></li>
          <li><a href="../../FAQ">FAQ</a></li>
          <li><a href="../../resources">Resources</a></li>
          <li><a href="../../newsletter">Newsletter</a></li>
        </ul>
      </nav>
    </div>
    <div id="SiteName" style="text-align:left">
      Hangprinter v4 Manual
    </div>
    <div id="MainContent">
      <a href="https://gitlab.com/tobben/hangprinter-org/edit/master/doc/v4/index.html">📝Edit on Gitlab</a>
    <h3>Status Of This Document</h3>
      <p>
        This documentation might still have gaping holes here and there.
        If you're building a v4, say hi and connect with other builders in the <a href="https://discord.gg/83G3XnPFXh">discord channel</a>.
      </p>
    <h3>Table of Contents</h3>
      <ul>
        <li><a href="#Sourcing">Sourcing</a></li>
        <li><a href="#Hardware_assembly">Hardware Assembly</a></li>
        <li><a href="#Wiring">Wiring</a></li>
        <li><a href="#Mounting">Mounting</a></li>
        <li><a href="#Calibrating_anchors_and_spool_buildup">Calibrating Anchors and Spool Buildup</a></li>
        <li><a href="#Slicing_and_Usage">Slicing and Usage</a></li>
        <li><a href="#Final_Words">Final Words</a></li>
      </ul>
    <h3 id="Sourcing">Sourcing and Preparing Wiring Loom</h3>
      <figure>
        <a href="https://docs.google.com/spreadsheets/d/1_mMTEF9ZFapn_3FrBvEydh70IPTaQG9gKZ7IVj9G2uM/edit?usp=sharing" target="_blank">
          <img src="./media/check-list.png" alt="" width="500" height="333">
        </a>
        <figcaption>
          Please see the <a href="https://docs.google.com/spreadsheets/d/1_mMTEF9ZFapn_3FrBvEydh70IPTaQG9gKZ7IVj9G2uM/edit?usp=sharing" target="_blank">bill of materials</a> (a Google Docs spreadsheet).
        </figcaption>
      </figure>
      </p>
    <h3 id="Hardware_assembly">Hardware Assembly</h3>
      <p>
        In the <a href="https://gitlab.com/tobben/hangprinter/-/tree/version_4/">repo</a>, there's an Openscad file called <code>layout.scad</code>.
        Open that file with Openscad.
        It shows all the parts, including where and how they're supposed to be mounted.
      </p>
      <figure>
        <a href="./media/layout.png" target="_blank">
          <img src="./media/layout_small.png" alt="" width="500" height="429">
        </a>
        <figcaption>
          This view of the ceiling unit greets you when you open the layout.scad file with Openscad.
          Rotate the view (inside Openscad) by clicking and dragging with your mouse.
          Zoom by scrolling your scroll wheel.
        </figcaption>
      </figure>
      <p>
        To help positioning parts on the ceiling unit,
        2d print out the <a href="https://gitlab.com/tobben/hangprinter/-/raw/version_4/layout_a4.pdf?inline=false">layout_a4.pdf</a>
        and use it as a template.
      </p>
      <p>
        As for the circuit boards and the power supply, place them out in a configuration similar to this:
        <figure>
          <a href="./media/pcb_and_psu_placement.jpeg" target="_blank">
            <img src="./media/pcb_and_psu_placement_small.jpeg" alt="" width="500" height="343">
          </a>
          <figcaption>
            Click the image to open a larger version.
            Works for all images in this manual.
          </figcaption>
        </figure>
        <figure>
          <a href="./media/believe.jpeg" target="_blank">
            <img src="./media/believe_small.jpeg" alt="" width="500" height="507">
          </a>
          <figcaption>
          </figcaption>
        </figure>
      </p>
      <p>
        Hot tips for circuit board placement:
        <ul>
          <li>Use the spacers shipped with the ODrives also for the Duet3.</li>
          <li>The Raspberry Pi uses spacers that are twice as long, which may be 3d printed (see <a href="https://gitlab.com/tobben/hangprinter/-/blob/version_4/stl/pi_mount.stl">pi_mount</a> stl in the repo).</li>
          <li>Make sure that the Duet3's USB port and SD slot are not covered by a 1XD card.</li>
          <li>Make sure the Pi's HDMI1 port is not covered by the Duet3.</li>
        </ul>
      </p>
      <h4 id="motor_brackets">Motor Brackets</h4>
      <p>
        The motor only fits in the bracket if inserted in one exact rotational position.
        Moreover, A and D motors fit in a different position than B and C motors, like this:
      </p>
      <figure>
        <a href="./media/motor_wire_directions.JPG" target="_blank">
          <img src="./media/motor_wire_directions_small.JPG" alt="" width="500" height="281">
        </a>
        <figcaption>
          Notice that the electrical wires from the A and D motors point downwards in the image, while those from the B and C motors point upwards.
        </figcaption>
      </figure>
      <p>
        It can be tricky to get the nuts into the right places on the motor brackets.
        For each bracket,
        start with taping a nut to the backside of the encoder holder, like this:
      </p>
        <figure>
          <a href="./media/insert_nut_in_motor_bracket.JPG" target="_blank">
            <img src="./media/insert_nut_in_motor_bracket_small.JPG" alt="" width="500" height="281">
          </a>
          <figcaption>
          </figcaption>
        </figure>
        <figure>
          <a href="./media/tape_over_nut_in_motor_bracket.JPG" target="_blank">
            <img src="./media/tape_over_nut_in_motor_bracket_small.JPG" alt="" width="500" height="281">
          </a>
          <figcaption>
          </figcaption>
        </figure>

      <h4 id="sand_edge">Areas That Must Be Smooth</h4>
      <p>
        The line is easy to fray, and 3d-printing sometimes leaves sharp and pointy edges.
        It's therefore recommended to sand down the inside of the spool disc, like this:
      </p>
      <figure>
        <a href="./media/sand_edge.JPG" target="_blank">
          <img src="./media/sand_edge_small.JPG" alt="" width="500" height="281">
        </a>
        <figcaption>
        </figcaption>
      </figure>
      <p>
        Also sand the GT2 spool gear's inside, since it will also rub against the line.
      </p>

      <h4 id="rotate_straight">Make Sure Spools Rotate Without Wobble</h4>
      <p>
        First of all, press a bearing into each spool, and rotate each spool separately on your 8mm spool core rod.
      </p>
      <figure>
         <video width="500" height="890" controls="controls">
            <source src="./media/MOV_1449.mp4" type="video/mp4"></source>
            <!--source src="movie.ogg" type="video/ogg"-->
                     Your browser does not support the video tag.
         </video>
         <figcaption>
           This one is straight enough.
         </figcaption>
      </figure>
      <p>
        If a spool has warped, it's useless.
        Otherwise, if it rotates straight enough, move on to the next step: snapping on the GT2 spool gear.
      </p>
      <p>
        The spool and the GT2 spool gear snap together with a very tight tolerance.
        When you press fit them together, you can usually hear a sharp "tick" each time the two parts' layer lines mesh in place.
      </p>
      <p>
        A common problem is that the GT2 spool gear is so tight, that it warps the whole spool, and/or doesn't mesh with the same layer line all around the spool.
        Check this with a similar test as before.
      </p>
      <figure>
         <video width="500" height="890" controls="controls">
            <source src="./media/MOV_1450.mp4" type="video/mp4"></source>
            <!--source src="movie.ogg" type="video/ogg"-->
                     Your browser does not support the video tag.
         </video>
         <figcaption>
           This one wobbles too much.
         </figcaption>
      </figure>
      <p>
        If you see wobbly rotation like in the video above, you must take off your GT2 gear from your spool and file/sand down sharp edges and layer lines.
      </p>
      <p>
        Take off any squeezed out edge from top/bottom layers on both GT2 spool gear, and on the spool itself.
        In some cases, I also widen the pocket on the top of the spool, where the inner tooth of the GT2 spool gear sinks into.
      </p>
      <figure>
        <a href="./media/widen_pocket.JPG" target="_blank">
          <img src="./media/widen_pocket_small.JPG" alt="" width="500" height="281">
        </a>
        <figcaption>
        </figcaption>
      </figure>
      <p>
        Getting all spools to rotate straight will help your machine become more silent, because it won't rub into the inner walls of the spool cover.
        It will also make your machine more safe, because it will help the spool cover casettes fully enclose your spools so that line can't escape and get tangled into the motor.
      </p>
    <h3 id="Wiring">Wiring</h3>
      <p>
        Warning: The motor wires must be connected in the exact order shown below.
        Otherwise torque mode will run backwards and create chaos.
        Also, auto-calibration won't work because signs will be reversed.
      </p>
      <figure>
        <a href="./media/motor_wire_order.png" target="_blank">
          <img src="./media/motor_wire_order_small.png" alt="" width="500" height="343">
        </a>
        <figcaption>
          Note the order of motor wires.
          Because of a limitation in RepRapFirmware for the time being (Jan 2022), we must
          connect the motor wires in exactly this order.
        </figcaption>
      </figure>

      <p>
        For all other wiring see
        <ul>
          <li><a href="https://duet3d.dozuki.com/Wiki/Getting_Started_With_Duet_3">Duet 3 docs</a>,</li>
          <li><a href="https://duet3d.dozuki.com/Wiki/Duet_3_Expansion_1XD">1XD expansion board docs</a>,</li>
          <li><a href="https://docs.odriverobotics.com/">ODrive docs</a>.</li>
        </ul>
      </p>
    <h4>The Two CAN Buses</h4>
      <p>
        The Duet3 has two CAN buses coming out of its RJ11 (6P4C) contact.
        These two CAN buses live separately, in two different pairs of wires.
      </p>
      <p>
        The two centermost conductors in the 6P4C contact carry the main CAN bus.
        It transfers step/dir signals from the Duet3 to the 1XDs.
      </p>
      <p>
        <figure>
          <a href="./media/1XD_addresses.jpeg" target="_blank">
            <img src="./media/1XD_addresses_small.jpeg" alt="" width="500" height="281">
          </a>
          <figcaption>
            The main CAN bus goes inside the white wire, from the Duet3 to board 43, to board 42, to board 41, to board 40.
            Board 40 should have termination jumpers on. The other 1XD boards should not.
          </figcaption>
        </figure>
        <figure>
          <a href="./media/easier_to_see2.jpeg" target="_blank">
            <img src="./media/easier_to_see2_small.jpeg" alt="" width="500" height="889">
          </a>
          <figcaption>
            The main CAN bus goes inside the white wire, from the Duet3 to board 43, to board 42, to board 41, to board 40.
            Board 40 should have termination jumpers on. The other 1XD boards should not.
          </figcaption>
        </figure>
      </p>
      <p>
        The rightmost and leftmost pins are not in use in 6P4C contacts.
        So we have two remaining conductors that are not used by the main CAN bus.
        The two remaining conductors carry the ODrives' CAN bus.
      </p>
      <p>
        <figure>
          <a href="./media/signal_wire_guy2.jpeg" target="_blank">
            <img src="./media/signal_wire_guy2_small.jpeg" alt="" width="500" height="281">
          </a>
          <figcaption>
            The jumper wires carry the ODrives' CAN signal from the telephone cable into the ODrive.
          </figcaption>
        </figure>
      </p>
      <p>
        The ODrives' CAN bus also goes inside the white wire, at least on my machine.
        It goes from the Duet3, through board 43, branches off into one ODrive, the other branch continues through board 42, through board 41, and ends in the second ODrive (left one on the image below).
        The 1XD boards does not and can not read the ODrives' CAN bus. It just passes straight through the 1XD boards.
      </p>
      <p>
        With the ODrive CAN bus wired up, make sure you set the termination resistors correctly:
        <figure>
          <a href="./media/term_R_ODrives.jpeg" target="_blank">
            <img src="./media/term_R_ODrives_small.jpeg" alt="" width="500" height="281">
          </a>
          <figcaption>
            There are little switches inside the red circles, that flip CAN termination resistors on and off.
          </figcaption>
        </figure>
      </p>


    <h3 id="Mounting">Mounting</h3>
      <p>
        This part hasn't changed between HP3 and HP4, so I'm linking to old HP3 documentation for now:
      </p>
      <ul>
        <li><a href="https://www.youtube.com/watch?v=iOwjbu2UMlQ&feature=youtu.be&t=3h54m43s">HP3 Build With tobben & Thomas Sanladerer (link directly into mounting)</a></li>
      </ul>
      <p>
        Make sure anchors are rigid. Also, make sure your lines form nice <a href="https://en.wikipedia.org/wiki/Parallelogram">Parallelograms</a> (two pairs of parallel sides).
      </p>
    <h4 id="line_termination">Line Termination</h4>
      <p>
        I use the <a href="https://en.wikipedia.org/wiki/Figure-eight_knot">eight shaped stop knot</a> to attach the line to the spool, like this:
      </p>
      <!--figure>
        <a href="./media/eight_shaped_stop_knot.JPG" target="_blank">
          <img src="./media/eight_shaped_stop_knot_small.JPG" alt="" width="500" height="281">
        </a>
        <figcaption>
        </figcaption>
      </figure-->
      <figure>
        <a href="./media/eight_shaped_stop_knot2.JPG" target="_blank">
          <img src="./media/eight_shaped_stop_knot2_small.JPG" alt="" width="500" height="281">
        </a>
        <figcaption>
        </figcaption>
      </figure>
      <p>
        The ABC-lines are all terminated in the clamp at the top of the snaily snail:
      </p>
      <figure>
        <a href="./media/line_attachment_snaily_snail.JPG" target="_blank">
          <img src="./media/line_attachment_snaily_snail_small.JPG" alt="" width="500" height="281">
        </a>
        <figcaption>
        </figcaption>
      </figure>
      <p>
        The clamp is a safety mechanism.
        In case of a sudden high force in the line (if someone trips in a line), the clamp is supposed to release the line.
        It's therefore important that the line protruding on the back side of the clamp is short.
        It's also important that all braiding is combed out near the end of the line so that the line can be clamped down flat,
        and no knot or tangle can form on the back side of the clamp, and prevent the safety mechanism from releasing the line.
      </p>
      <p>
        The D-lines are terminated in the ceiling unit.
        I terminate them with a wood screw, like this:
      </p>
      <figure>
        <a href="./media/D_line_termination.JPG" target="_blank">
          <img src="./media/D_line_termination_small.JPG" alt="" width="500" height="281">
        </a>
        <figcaption>
        </figcaption>
      </figure>

    <h4>Optional Hoisting System</h4>
      <p>
        Screwing the ceiling unit onto the ceiling can be a bit challenging.
        I therefore added a hoisting system to my own HP4.
        See it in <a href="https://twitter.com/tobbelobb/status/1428025129406238723">this tweet</a> and <a href="https://youtu.be/coI8I0QsQFI">this video</a>.
        The little CAD models I used are shared <a href="https://gitlab.com/tobben/hoistit/">here</a>.
      </p>
      <figure>
        <a href="./media/hoistit.JPG" target="_blank">
          <img src="./media/hoistit_small.JPG" alt="" width="500" height="281">
        </a>
        <figcaption>
          The optional hoisting system. Note that the top bearings here are U-groove M4 core bearings (sry, just what I had lying around).
          The bearings on the ceiling plate is 623 vgroove bearings, like are used in other places in the Hangprinter v4 design.
        </figcaption>
      </figure>
    <h3>Firmwares and Configuration</h3>
    <p>
      Stock RepRapFirmware will work in the future, but for now, I publish the RepRapFirmware I use here:
      <a href="https://gitlab.com/tobben/hangprinter/-/blob/version_4/firmware/RepRapFirmware/Duet3/Duet3Firmware_MB6HC.bin">link</a>.
      Stock ODrivefirmware works for us out of the box.
      However, I'm stuck at the 0.5.1 version of ODrivefirmware, because the anti-cogging feature is broken in later releases.
      Anti-cogging is used to make torque mode more smooth.
    </p>
    <p>
      Please look closely at my config files:
      <ul>
        <li><a href="https://gitlab.com/tobben/hangprinter/-/blob/version_4/firmware/RepRapFirmware/Duet3/config.g">config.g for RepRapFirmware</a></li>
        <li><a href="https://gitlab.com/tobben/hangprinter/-/tree/version_4/firmware/ODrive">configure_odrive.py for ODrivefirmware</a></li>
      </ul>
    </p>

    <h3 id="Calibrating_anchors_and_spool_buildup">Calibrating Anchors and Spool Buildup</h3>
      <p>
        This has changed a lot between HP3 and HP4.
        A computer vision system called hp-mark has been developed to assist, and largely automate, the calibration process.
        The system has been built and proved, see this video:
      </p>
      <figure>
        <div class='embed-container'>
          <iframe src='https://www.youtube.com/embed/As3Y5J2NTGA'
            frameborder='0'
            allowfullscreen='true'>
          </iframe>
        </div>
      </figure>

    <h4>Replicating What's Going On In That Video</h4>
      <p>
        Ok, this will be a bit messy.
        hp-mark is still very much in beta, and requires the user to be comfortable doing a few things via the Unix terminal.
        Our main goal is to be able to run the script called <a href="https://gitlab.com/tobben/hp-mark/-/blob/master/use/get_auto_calibration_data_automatically.sh">get_auto_calibration_data_automatically.sh</a>.
      </p>
      <p>
        The computer vision system is called hp-mark.
        It consists of
        <ul>
          <li>A camera with LED lights around it,</li>
          <li>A Raspberry Pi who controls the camera and the LEDs,</li>
          <li>Six retro-reflective markers,</li>
          <li>A computer program called hpm</li>
          <li>A main computer who gets images from the Raspberry Pi, and uses hpm to analyze the images.</li>
        </ul>
        See the <a href="https://gitlab.com/tobben/hp-mark">hp-mark repo</a>,
        and in particular the <code>README.md</code> and the <code>doc</code> directory for more guidance on how to set up hp-mark.
        The rest of this section will describe how to use hp-mark correctly with Hangprinter v4.
      </p>
      <p>
        The get_auto_calibration_data_automatically.sh script is executed on the main computer.
        It expects your camera-connected Raspberry to be available
        at the ip called <code>rpi</code> in your <code>/etc/hosts</code> file.
        It's also assuming your Duet3 connected Raspberry to be called <code>duet3</code> in your <code>/etc/hosts</code>.
      </p>
      <p>
        It's fine if <code>duet3</code> and <code>rpi</code> are actually the same Raspberry Pi board.
        Just configure them to the same ip address.
      </p>
      <p>
        The Raspberry Pi needs the camera to be connected and calibrated (as described in the <a href="https://gitlab.com/tobben/hp-mark">hp-mark repo</a>), and it needs ssh to be enabled.
        It also needs a version of raspistill that matches your lens, or else your images' colors will be <a href="https://www.arducam.com/docs/cameras-for-raspberry-pi/native-raspberry-pi-cameras/lens-shading-calibration/">tinted</a>.
        To get the one I use (matching my Arducam lo-distortion 45 deg lens), do
      </p>
      <p>
        <code>
          $ ssh pi@rpi<br />
          $ mkdir -p repos<br />
          $ cd repos<br />
          $ git clone https://github.com/ArduCAM/NativePiCamera.git<br />
          $ cd NativePiCamera/bin<br />
          $ chmod u+x raspistill_CS_lens<br />
        </code>
      </p>
      <p>
        The duet3 official image is one comes with the camera disabled by default.
        To enable it do
      </p>
      <p>
        <code>
          $ sudo raspi-config<br />
          $ [Interface Options] -&gt; [Camera] -&gt; [Enable] -&gt; [Reboot yes]
        </code>
      </p>
      <p>
        We also have some LED rings around the lens (I have 20. Don's use more than 20, since the Rpi's 5V pin can't output much current).
        To light up the LEDs, I used these pins on the camera-connected Raspberry:
      </p>
      <figure>
        <a href="./media/LED_pinout.png" target="_blank">
          <img src="./media/LED_pinout.png" alt="" width="497" height="494">
        </a>
        <figcaption>
        </figcaption>
      </figure>
      <h4>If <code>rpi</code> and <code>duet3</code> Are One And the Same Board In Your Setup</h4>
      <p>
        The Duet3 doesn't use any of pins 4, 6, or 12, although its connector covers them up.
        To work around the connector, you can created a distance between Rpi and the connector with nine short jumper wires like this:
      </p>
      <figure>
        <a href="./media/Bypass_connector_3.JPG" target="_blank">
          <img src="./media/Bypass_connector_3_small.JPG" alt="" width="500" height="281">
        </a>
        <figcaption>
        </figcaption>
      </figure>
      <p>
      </p>
      <figure>
        <a href="./media/Duetpins2.png" target="_blank">
          <img src="./media/Duetpins2.png" alt="" width="498" height="123">
        </a>
        <figcaption>
        </figcaption>
      </figure>
      <p>
          Connect the Raspberry's pins 17-25 with the Duet, as they would have been connected through the standard connector.
          Power the Raspberry Pi with a separate wallplug power supply.
          The official Raspberry Pi Power supply is recommended.
      </p>
      <h4>Anyways...</h4>
      <p>
        Here's how you get code that lights up the LEDs:
      </p>
      <p>
        <code>
          $ ssh pi@rpi<br />
          $ mkdir -p repos<br />
          $ cd repos<br />
          $ git clone https://gitlab.com/tobben/rpi_ws281x.git<br />
          $ sudo apt install python3-pip<br />
          $ sudo pip3 install rpi_ws281x<br />
        </code>
      </p>
      <h4>Test If Camera Usage Works</h4>
      <p>
        On your main computer, try to take an image and analyze it:
      </p>
      <p>
        <code>
          $ cd &lt;path-to&gt;/hp-mark/use<br />
          $ ./use_ssh.sh --show result
        </code>
      </p>
      <p>
        If everything worked, the LEDs should have flashed, an image should be taken, downloaded, analyzed by your hpm program,
        and the result (an image) should be shown on the screen, like this:
      </p>
      <figure>
        <a href="./media/result.png" target="_blank">
          <img src="./media/result_small.png" alt="" width="500" height="376">
        </a>
        <figcaption>
        </figcaption>
      </figure>
      <p>
        The console output should be similar to this:
      </p>
      <p>
        <code>
          $ ./use_ssh.sh --show result<br />
/home/pi/repos/hp-mark/use<br />
Captured image remotely: /home/pi/repos/hp-mark/use/images/DiUBh.jpg.<br />
Copies home:<br />
DiUBh.jpg 100% 4512KB   4.9MB/s   00:00<br />
/home/tobben/repos/hp-mark/use<br />
Will execute:<br />
../hpm/hpm/hpm ../hpm/hpm/example-cam-params/loDistCamParams2.xml ../hpm/hpm/example-marker-params/my-marker-params.xml ./images/DiUBh.jpg --show result<br />
[5.22761, -28.5536, 6.5542];<br />
        </code>
      </p>
      <h4>Double Check Torque Mode</h4>
      <p>
        The get_auto_calibration_data_automatically.sh script will not only use your camera.
        It will also put your motors in torque mode.
        It assumes the
        <a href="https://gitlab.com/tobben/hangprinter/-/blob/version_4/firmware/RepRapFirmware/Duet3/macros/Torque_mode">Torque_mode macro</a>
        has been installed into your macro folder on the Duet3.
      </p>
      <p>
        Play with the torque mode script in the web interface before running the full calibration script.
        For example, in the web interface, go to the console and to
        set motor A in torque mode, with 0.02 Nm of torque.
        Feel the spool gently with your and and confirm that the motor tries to pull line inwards onto the spool
      </p>
      <code>
        M98 P"/macros/Torque_mode" A0.02
      </code>
      <p>
        Repeat for all motors ABCD.
      </p>
      <h4>Getting To The Actual Calibration</h4>
      <p>
        With camera and torque mode macro in place, if all the stars align, it should be possible for you to collect the calibration data like this:
      </p>
      <p>
        <code>$ cd path/to/hp-mark/use<br />
          $ ./get_auto_calibration_data_automatically.sh --show result</code>
      </p>
      <p>
        The <code>--show result</code> option will make hpm stop and show you each measurement when it's done, and wait for you to press
        Enter before it continues.
      </p>
      <figure>
        <a href="./media/result_hp_mark.png" target="_blank">
          <img src="./media/result_hp_mark_small.png" alt="" width="500" height="376">
        </a>
        <figcaption>
          Example of a successful data point collection with the <code>--show result</code> option enabled.
        </figcaption>
      </figure>
      <p>
        After collecting 18 data points (don't worry if a few were unsuccessful or printed a warning), it prints out the data it has collected
        in a format that copy/paste friendly for the next script we're going to use: <a href="https://gitlab.com/tobben/auto-calibration-simulation-for-hangprinter/-/blob/hp_mark_adjusted/simulation.py">simulation.py</a>.
      </p>
      <p>
        The output of simulation.py needs to be adjusted by yet another script, called just <a href="https://gitlab.com/tobben/auto-calibration-simulation-for-hangprinter/-/blob/hp_mark_adjusted/harmonize/script.m">script.m</a>.
      </p>
      <p>
        If again, all stars align, you can re-run simulation.py as described inside script.m, and you'll end up with a perfect set of M669 and M666 commands, to copy/paste into your <a href="https://gitlab.com/tobben/hangprinter/-/blob/version_4/firmware/RepRapFirmware/Duet3/config.g">config.g</a>.
      </p>
      <p>
        For anyone who have reached this far: I salute you.
        Reach me via Discord and tell me you need the auto calibration stuff, and I'll up-prioritize automating further and documenting better.
      </p>
    <h3 id="Slicing_and_Usage">Slicing and Usage</h3>
      <p>
        I've published the Prusa Slicer configs that I use at <a href="https://gitlab.com/tobben/prusaslicer-configs">gitlab.com/tobben/prusaslicer-configs</a>.
      </p>
    <h4>Avoid Line Collisions</h4>
      <p>
        Before you start a large print, it's recommended to check if your model fits the print volume or not.
        This is done with <a href="https://gitlab.com/hangprinter/line-collision-detector">line-collision-detector</a>, a tool that is developed specifically for Hangprinter build volume verification.
      </p>
      <figure>
        <a href="./media/debug_stl.png" target="_blank">
          <img src="./media/debug_stl_small.png" alt="" width="500" height="395">
        </a>
        <figcaption>
          line-collision-detector spits out a debug stl like this one upon detecting collision (if you asked for it).
        </figcaption>
      </figure>
      <p>
        Please note that many slicers will auto center the model before slicing it.
        line-collision-detector will not do that.
        Since you probably want to check if the centered version of your model collides with lines or not, it's recommended to first import your model in the slicer, and then export it from the slicer as an stl, and then run it through the line-collision-detector.
      </p>
      <br /><br /><br />
    <h3 id="Final_Words">Final Words</h3>
      <p>
        Building, mounting, calibrating, and running a HP4 is a big undertaking, and many of the steps are sparsely documented, but you are not alone.
        Be sure to check out the <a href="../../resources">resources</a>, there are some quite good ones.
      </p>
      <p>
        If you spot an error or a missing link in the documentation, then please fix it and contribute the fix back to the repo.
        But also, do come by the Discord and say hi, or have a chat via Gitlab merge request or issue.
      </p>
      <p>
        - tobben 👷
      </p>
        <br /><br /><br /><br /><br /><br /><br />
      </p>
      <p>
        The raw text source of this manual is published under the <a href="https://gitlab.com/tobben/hangprinter/-/blob/version_4/LICENSE" target="_blank">GPL-2.0 license</a>, and is being maintained in the <a href="https://gitlab.com/tobben/hangprinter-org" target="_blank">hangprinter-org repo</a>. All images and videos are also published under the GPL-2.0.
      </p>
    </div>
    <script data-goatcounter="https://hangprinter.goatcounter.com/count"
            async src="//gc.zgo.at/count.js"></script>
  </body>
</html>
